local lib, oldMinor = LibStub:NewLibrary("LibArmorToken-1.0", 1)
if not lib then return end

local items

-- API

function lib:ItemIsToken(itemid)
    if items[itemid] then
        return true
    end
end

do
    local t = {}
    function lib:IterateClassesForToken(itemid)
        if not items[itemid] then
            return ipairs({})
        end
        wipe(t)
        for cl in pairs(items[itemid]) do
            table.insert(t, cl)
        end
        return ipairs(t)
    end
end

function lib:IterateItemsForTokenAndClass(itemid, class)
    if not (items[itemid] and items[itemid][class]) then
        return ipairs({})
    end
    return ipairs(items[itemid][class])
end

-- DATA
items = {
    -- This is generated by update.py
    [119305] = { -- Chest of the Iron Conqueror
        PALADIN = {115566},
        PRIEST = {115560},
        WARLOCK = {115588},
    },
    [119306] = { -- Gauntlets of the Iron Conqueror
        PALADIN = {115567},
        PRIEST = {115562},
        WARLOCK = {115585},
    },
    [119307] = { -- Leggings of the Iron Conqueror
        PALADIN = {115569},
        PRIEST = {115564},
        WARLOCK = {115587},
    },
    [119308] = { -- Helm of the Iron Conqueror
        PALADIN = {115568},
        PRIEST = {115563},
        WARLOCK = {115586},
    },
    [119309] = { -- Shoulders of the Iron Conqueror
        PALADIN = {115565},
        PRIEST = {115561},
        WARLOCK = {115589},
    },
    [119311] = { -- Gauntlets of the Iron Vanquisher
        DEATHKNIGHT = {115538},
        DRUID = {115541},
        MAGE = {115552},
        ROGUE = {115571},
    },
    [119312] = { -- Helm of the Iron Vanquisher
        DEATHKNIGHT = {115539},
        DRUID = {115542},
        MAGE = {115553},
        ROGUE = {115572},
    },
    [119313] = { -- Leggings of the Iron Vanquisher
        DEATHKNIGHT = {115535},
        DRUID = {115543},
        MAGE = {115554},
        ROGUE = {115573},
    },
    [119314] = { -- Shoulders of the Iron Vanquisher
        DEATHKNIGHT = {115536},
        DRUID = {115544},
        MAGE = {115551},
        ROGUE = {115574},
    },
    [119315] = { -- Chest of the Iron Vanquisher
        DEATHKNIGHT = {115537},
        DRUID = {115540},
        MAGE = {115550},
        ROGUE = {115570},
    },
    [119318] = { -- Chest of the Iron Protector
        HUNTER = {115548},
        MONK = {115558},
        SHAMAN = {115577},
        WARRIOR = {115582},
    },
    [119319] = { -- Gauntlets of the Iron Protector
        HUNTER = {115549},
        MONK = {115555},
        SHAMAN = {115578},
        WARRIOR = {115583},
    },
    [119320] = { -- Leggings of the Iron Protector
        HUNTER = {115546},
        MONK = {115557},
        SHAMAN = {115575},
        WARRIOR = {115580},
    },
    [119321] = { -- Helm of the Iron Protector
        HUNTER = {115545},
        MONK = {115556},
        SHAMAN = {115579},
        WARRIOR = {115584},
    },
    [127953] = { -- Chest of Hellfire's Conqueror
        DEMONHUNTER = {139625},
        PALADIN = {124318},
        PRIEST = {124172},
        WARLOCK = {124173},
    },
    [127954] = { -- Gauntlets of Hellfire's Conqueror
        DEMONHUNTER = {139626},
        PALADIN = {124328},
        PRIEST = {124155},
        WARLOCK = {124156},
    },
    [127955] = { -- Leggings of Hellfire's Conqueror
        DEMONHUNTER = {139628},
        PALADIN = {124339},
        PRIEST = {124166},
        WARLOCK = {124167},
    },
    [127956] = { -- Helm of Hellfire's Conqueror
        DEMONHUNTER = {139627},
        PALADIN = {124333},
        PRIEST = {124161},
        WARLOCK = {124162},
    },
    [127957] = { -- Shoulders of Hellfire's Conqueror
        DEMONHUNTER = {139629},
        PALADIN = {124345},
        PRIEST = {124178},
        WARLOCK = {124179},
    },
    [127958] = { -- Gauntlets of Hellfire's Vanquisher
        DEATHKNIGHT = {124327},
        DRUID = {124255},
        MAGE = {124154},
        ROGUE = {124257},
    },
    [127959] = { -- Helm of Hellfire's Vanquisher
        DEATHKNIGHT = {124332},
        DRUID = {124261},
        MAGE = {124160},
        ROGUE = {124263},
    },
    [127960] = { -- Leggings of Hellfire's Vanquisher
        DEATHKNIGHT = {124338},
        DRUID = {124267},
        MAGE = {124165},
        ROGUE = {124269},
    },
    [127961] = { -- Shoulders of Hellfire's Vanquisher
        DEATHKNIGHT = {124344},
        DRUID = {124272},
        MAGE = {124177},
        ROGUE = {124274},
    },
    [127962] = { -- Chest of Hellfire's Vanquisher
        DEATHKNIGHT = {124317},
        DRUID = {124246},
        MAGE = {124171},
        ROGUE = {124248},
    },
    [127963] = { -- Chest of Hellfire's Protector
        HUNTER = {124284},
        MONK = {124247},
        SHAMAN = {124303},
        WARRIOR = {124319},
    },
    [127964] = { -- Gauntlets of Hellfire's Protector
        HUNTER = {124292},
        MONK = {124256},
        SHAMAN = {124293},
        WARRIOR = {124329},
    },
    [127965] = { -- Leggings of Hellfire's Protector
        HUNTER = {124301},
        MONK = {124268},
        SHAMAN = {124302},
        WARRIOR = {124340},
    },
    [127966] = { -- Helm of Hellfire's Protector
        HUNTER = {124296},
        MONK = {124262},
        SHAMAN = {124297},
        WARRIOR = {124334},
    },
    [127967] = { -- Shoulders of Hellfire's Protector
        HUNTER = {124307},
        MONK = {124273},
        SHAMAN = {124308},
        WARRIOR = {124346},
    },
    [127968] = { -- Badge of Hellfire's Vanquisher
        DEATHKNIGHT = {124513},
        DRUID = {124514},
        MAGE = {124516},
        ROGUE = {124520},
    },
    [127969] = { -- Badge of Hellfire's Conqueror
        PALADIN = {124518},
        PRIEST = {124519},
        WARLOCK = {124522},
    },
    [127970] = { -- Badge of Hellfire's Protector
        HUNTER = {124515},
        MONK = {124517},
        SHAMAN = {124521},
        WARRIOR = {124523},
    },
    [29753] = { -- Chestguard of the Fallen Defender
        DRUID = {28130, 29091, 29096, 28140, 31379, 29087},
        PRIEST = {29056, 29050, 31413, 27711},
        WARRIOR = {24544, 29019, 29012},
    },
    [29754] = { -- Chestguard of the Fallen Champion
        PALADIN = {29062, 27879, 29066, 29071, 27702, 31613},
        ROGUE = {29045, 25831},
        SHAMAN = {31396, 29029, 29033, 27469, 25997, 29038},
    },
    [29755] = { -- Chestguard of the Fallen Hero
        HUNTER = {29082, 28334},
        MAGE = {25856, 29077},
        WARLOCK = {24552, 28964, 30200},
    },
    [29756] = { -- Gloves of the Fallen Hero
        HUNTER = {29085, 28335},
        MAGE = {29080, 25857},
        WARLOCK = {28968, 30188, 24556},
    },
    [29757] = { -- Gloves of the Fallen Champion
        PALADIN = {27880, 29065, 29067, 29072, 27703, 31614},
        ROGUE = {29048, 25834},
        SHAMAN = {31397, 29032, 29034, 27470, 29039, 26000},
    },
    [29758] = { -- Gloves of the Fallen Defender
        DRUID = {29090, 29092, 28136, 29097, 31375, 28126},
        PRIEST = {31409, 29057, 27707, 29055},
        WARRIOR = {29017, 29020, 24549},
    },
    [29759] = { -- Helm of the Fallen Hero
        HUNTER = {29081, 28331},
        MAGE = {29076, 25855},
        WARLOCK = {24553, 28963, 30187},
    },
    [29760] = { -- Helm of the Fallen Champion
        PALADIN = {31616, 29061, 27881, 29068, 29073, 27704},
        ROGUE = {29044, 25830},
        SHAMAN = {29028, 31400, 29035, 25998, 27471, 29040},
    },
    [29761] = { -- Helm of the Fallen Defender
        DRUID = {29093, 28137, 29098, 31376, 29086, 28127},
        PRIEST = {29049, 31410, 27708, 29058},
        WARRIOR = {24545, 29011, 29021},
    },
    [29762] = { -- Pauldrons of the Fallen Hero
        HUNTER = {29084, 28333},
        MAGE = {25854, 29079},
        WARLOCK = {30186, 24554, 28967},
    },
    [29763] = { -- Pauldrons of the Fallen Champion
        PALADIN = {31619, 29064, 27883, 29070, 29075, 27706},
        ROGUE = {25832, 29047},
        SHAMAN = {29031, 29037, 31407, 25999, 27473, 29043},
    },
    [29764] = { -- Pauldrons of the Fallen Defender
        DRUID = {28129, 29089, 29095, 28139, 29100, 31378},
        PRIEST = {29060, 29054, 31412, 27710},
        WARRIOR = {29016, 24546, 29023},
    },
    [29765] = { -- Leggings of the Fallen Hero
        HUNTER = {29083, 28332},
        MAGE = {25858, 29078},
        WARLOCK = {30201, 24555, 28966},
    },
    [29766] = { -- Leggings of the Fallen Champion
        PALADIN = {31618, 29063, 27882, 29069, 29074, 27705},
        ROGUE = {25833, 29046},
        SHAMAN = {29030, 29036, 31406, 27472, 26001, 29042},
    },
    [29767] = { -- Leggings of the Fallen Defender
        DRUID = {28128, 29088, 29094, 28138, 29099, 31377},
        PRIEST = {31411, 29059, 27709, 29053},
        WARRIOR = {24547, 29022, 29015},
    },
    [30236] = { -- Chestguard of the Vanquished Champion
        PALADIN = {32039, 30123, 30129, 32020, 30134, 31992},
        ROGUE = {30144, 32002},
        SHAMAN = {32004, 32009, 30185, 30164, 30169, 32029},
    },
    [30237] = { -- Chestguard of the Vanquished Defender
        DRUID = {31972, 30216, 30222, 30231, 31991, 32060},
        PRIEST = {32019, 30150, 32038, 30159},
        WARRIOR = {30113, 30118, 30486},
    },
    [30238] = { -- Chestguard of the Vanquished Hero
        HUNTER = {31960, 30139},
        MAGE = {32050, 30196},
        WARLOCK = {31977, 31982, 30214},
    },
    [30239] = { -- Gloves of the Vanquished Champion
        PALADIN = {32040, 30124, 30130, 32021, 30135, 31993},
        ROGUE = {30145, 31998},
        SHAMAN = {32005, 32010, 30189, 30165, 30170, 32030},
    },
    [30240] = { -- Gloves of the Vanquished Defender
        DRUID = {30217, 30232, 30223, 31987, 32056, 31967},
        PRIEST = {30160, 30151, 32034, 32015},
        WARRIOR = {30119, 30114, 30487},
    },
    [30241] = { -- Gloves of the Vanquished Hero
        HUNTER = {31961, 30140},
        MAGE = {32049, 30205},
        WARLOCK = {31981, 30211, 31973},
    },
    [30242] = { -- Helm of the Vanquished Champion
        PALADIN = {32041, 30125, 30131, 32022, 30136, 31997},
        ROGUE = {30146, 31999},
        SHAMAN = {32006, 32011, 30190, 30166, 30171, 32031},
    },
    [30243] = { -- Helm of the Vanquished Defender
        DRUID = {31968, 30219, 30233, 31988, 30228, 32057},
        PRIEST = {32016, 30161, 32035, 30152},
        WARRIOR = {30488, 30115, 30120},
    },
    [30244] = { -- Helm of the Vanquished Hero
        HUNTER = {31962, 30141},
        MAGE = {32048, 30206},
        WARLOCK = {31980, 30212, 31974},
    },
    [30245] = { -- Leggings of the Vanquished Champion
        PALADIN = {32042, 30126, 30132, 32023, 30137, 31995},
        ROGUE = {32000, 30148},
        SHAMAN = {32032, 32007, 32012, 30192, 30167, 30172},
    },
    [30246] = { -- Leggings of the Vanquished Defender
        DRUID = {31969, 30220, 30234, 30229, 31989, 32058},
        PRIEST = {32017, 30153, 30162, 32036},
        WARRIOR = {30489, 30121, 30116},
    },
    [30247] = { -- Leggings of the Vanquished Hero
        HUNTER = {31963, 30142},
        MAGE = {32051, 30207},
        WARLOCK = {31983, 30213, 31975},
    },
    [30248] = { -- Pauldrons of the Vanquished Champion
        PALADIN = {32043, 30127, 30133, 32024, 30138, 31996},
        ROGUE = {32001, 30149},
        SHAMAN = {32033, 32008, 32013, 30194, 30168, 30173},
    },
    [30249] = { -- Pauldrons of the Vanquished Defender
        DRUID = {31971, 30221, 32059, 31990, 30230, 30235},
        PRIEST = {30154, 32018, 30163, 32037},
        WARRIOR = {30122, 30490, 30117},
    },
    [30250] = { -- Pauldrons of the Vanquished Hero
        HUNTER = {31964, 30143},
        MAGE = {30210, 32047},
        WARLOCK = {31976, 31979, 30215},
    },
    [31089] = { -- Chestguard of the Forgotten Conqueror
        PALADIN = {32039, 30990, 30991, 30992, 32020, 31992},
        PRIEST = {31065, 31066, 32019, 32038},
        WARLOCK = {31977, 31052, 31982},
    },
    [31090] = { -- Chestguard of the Forgotten Vanquisher
        DRUID = {31041, 31042, 31043, 31972, 31991, 32060},
        MAGE = {31057, 32050},
        ROGUE = {32002, 31028},
    },
    [31091] = { -- Chestguard of the Forgotten Protector
        HUNTER = {31960, 31004},
        SHAMAN = {32004, 31016, 31017, 31018, 32009, 32029},
        WARRIOR = {30976, 30486, 30975},
    },
    [31092] = { -- Gloves of the Forgotten Conqueror
        PALADIN = {30982, 30983, 32040, 30985, 32021, 31993},
        PRIEST = {32034, 31060, 31061, 32015},
        WARLOCK = {31981, 31050, 31973},
    },
    [31093] = { -- Gloves of the Forgotten Vanquisher
        DRUID = {32056, 31987, 31032, 31034, 31035, 31967},
        MAGE = {32049, 31055},
        ROGUE = {31026, 31998},
    },
    [31094] = { -- Gloves of the Forgotten Protector
        HUNTER = {31001, 31961},
        SHAMAN = {31008, 31011, 32005, 32010, 32030, 31007},
        WARRIOR = {30969, 30970, 30487},
    },
    [31095] = { -- Helm of the Forgotten Protector
        HUNTER = {31962, 31003},
        SHAMAN = {31012, 32006, 31014, 31015, 32011, 32031},
        WARRIOR = {30488, 30972, 30974},
    },
    [31096] = { -- Helm of the Forgotten Vanquisher
        DRUID = {31040, 31968, 31988, 32057, 31037, 31039},
        MAGE = {31056, 32048},
        ROGUE = {31027, 31999},
    },
    [31097] = { -- Helm of the Forgotten Conqueror
        PALADIN = {32041, 30987, 30988, 30989, 32022, 31997},
        PRIEST = {31064, 32016, 32035, 31063},
        WARLOCK = {31051, 31980, 31974},
    },
    [31098] = { -- Leggings of the Forgotten Conqueror
        PALADIN = {32042, 30993, 30994, 30995, 32023, 31995},
        PRIEST = {32017, 31067, 31068, 32036},
        WARLOCK = {31975, 31053, 31983},
    },
    [31099] = { -- Leggings of the Forgotten Vanquisher
        DRUID = {31969, 31044, 31045, 31046, 31989, 32058},
        MAGE = {31058, 32051},
        ROGUE = {32000, 31029},
    },
    [31100] = { -- Leggings of the Forgotten Protector
        HUNTER = {31963, 31005},
        SHAMAN = {32032, 32007, 31019, 32012, 31020, 31021},
        WARRIOR = {30977, 30978, 30489},
    },
    [31101] = { -- Pauldrons of the Forgotten Conqueror
        PALADIN = {32043, 30996, 30997, 30998, 32024, 31996},
        PRIEST = {32018, 32037, 31069, 31070},
        WARLOCK = {31976, 31979, 31054},
    },
    [31102] = { -- Pauldrons of the Forgotten Vanquisher
        DRUID = {31971, 31047, 31048, 31049, 31990, 32059},
        MAGE = {31059, 32047},
        ROGUE = {32001, 31030},
    },
    [31103] = { -- Pauldrons of the Forgotten Protector
        HUNTER = {31964, 31006},
        SHAMAN = {32033, 32008, 32013, 31022, 31023, 31024},
        WARRIOR = {30490, 30979, 30980},
    },
    [34848] = { -- Bracers of the Forgotten Conqueror
        MAGE = {33883, 33901},
        PALADIN = {34432, 34433, 33889, 33904, 33910, 34431},
        PRIEST = {34434, 34435, 33883, 33901},
        WARLOCK = {33883, 34436, 33901},
        WARRIOR = {33904, 33889, 33910},
    },
    [34851] = { -- Bracers of the Forgotten Protector
        DEATHKNIGHT = {33876},
        HUNTER = {33897, 33906, 34443, 33876, 33894},
        PALADIN = {33813},
        SHAMAN = {34437, 33894, 34438, 34439, 33897, 33906, 33876},
        WARRIOR = {34441, 34442, 33813},
    },
    [34852] = { -- Bracers of the Forgotten Vanquisher
        DRUID = {33893, 34444, 34445, 34446, 33881, 33917, 33887},
        MAGE = {33913, 34447},
        MONK = {33881, 33893, 33917, 33887},
        PRIEST = {33913},
        ROGUE = {34448, 33881, 33893, 33917, 33887},
        WARLOCK = {33913},
    },
    [34853] = { -- Belt of the Forgotten Conqueror
        MAGE = {33882, 33900},
        PALADIN = {33888, 33903, 33909, 34485, 34487, 34488},
        PRIEST = {34528, 33882, 33900, 34527},
        WARLOCK = {33882, 33900, 34541},
        WARRIOR = {33888, 33909, 33903},
    },
    [34854] = { -- Belt of the Forgotten Protector
        HUNTER = {33898, 33907, 33877, 34549, 33895},
        PALADIN = {33811},
        SHAMAN = {33895, 33898, 34542, 34543, 34545, 33907, 33877},
        WARRIOR = {33811, 34546, 34547},
    },
    [34855] = { -- Belt of the Forgotten Vanquisher
        DRUID = {33891, 33915, 33879, 34554, 34555, 34556, 33885},
        MAGE = {33912, 34557},
        MONK = {33915, 33891, 33885, 33879},
        PRIEST = {33912},
        ROGUE = {33915, 33891, 33885, 34558, 33879},
        WARLOCK = {33912},
    },
    [34856] = { -- Boots of the Forgotten Conqueror
        MAGE = {33884, 33902},
        PALADIN = {34560, 34561, 33890, 33905, 33911, 34559},
        PRIEST = {34562, 34563, 33884, 33902},
        WARLOCK = {34564, 33902, 33884},
        WARRIOR = {33905, 33890, 33911},
    },
    [34857] = { -- Boots of the Forgotten Protector
        HUNTER = {33896, 34570, 33899, 33908, 33878},
        PALADIN = {33812},
        SHAMAN = {34565, 34566, 34567, 33896, 33899, 33908, 33878},
        WARRIOR = {34568, 34569, 33812},
    },
    [34858] = { -- Boots of the Forgotten Vanquisher
        DRUID = {33892, 34571, 34572, 34573, 33880, 33916, 33886},
        MAGE = {33914, 34574},
        MONK = {33880, 33916, 33892, 33886},
        PRIEST = {33914},
        ROGUE = {33880, 33916, 33892, 33886, 34575},
        WARLOCK = {33914},
    },
    [40610] = { -- Chestguard of the Lost Conqueror
        PALADIN = {39633, 39629, 39638},
        PRIEST = {39515, 39523},
        WARLOCK = {39497},
    },
    [40611] = { -- Chestguard of the Lost Protector
        HUNTER = {39579},
        SHAMAN = {39592, 39588, 39597},
        WARRIOR = {39611, 39606},
    },
    [40612] = { -- Chestguard of the Lost Vanquisher
        DEATHKNIGHT = {39617, 39623},
        DRUID = {39538, 39547, 39554},
        MAGE = {39492},
        ROGUE = {39558},
    },
    [40613] = { -- Gloves of the Lost Conqueror
        PALADIN = {39632, 39634, 39639},
        PRIEST = {39530, 39519},
        WARLOCK = {39500},
    },
    [40614] = { -- Gloves of the Lost Protector
        HUNTER = {39582},
        SHAMAN = {39593, 39601, 39591},
        WARRIOR = {39609, 39622},
    },
    [40615] = { -- Gloves of the Lost Vanquisher
        DEATHKNIGHT = {39624, 39618},
        DRUID = {39544, 39557, 39543},
        MAGE = {39495},
        ROGUE = {39560},
    },
    [40616] = { -- Helm of the Lost Conqueror
        PALADIN = {39640, 39635, 39628},
        PRIEST = {39521, 39514},
        WARLOCK = {39496},
    },
    [40617] = { -- Helm of the Lost Protector
        HUNTER = {39578},
        SHAMAN = {39602, 39594, 39583},
        WARRIOR = {39610, 39605},
    },
    [40618] = { -- Helm of the Lost Vanquisher
        DEATHKNIGHT = {39625, 39619},
        DRUID = {39545, 39553, 39531},
        MAGE = {39491},
        ROGUE = {39561},
    },
    [40619] = { -- Leggings of the Lost Conqueror
        PALADIN = {39641, 39636, 39630},
        PRIEST = {39528, 39517},
        WARLOCK = {39498},
    },
    [40620] = { -- Leggings of the Lost Protector
        HUNTER = {39580},
        SHAMAN = {39603, 39595, 39589},
        WARRIOR = {39612, 39607},
    },
    [40621] = { -- Leggings of the Lost Vanquisher
        DEATHKNIGHT = {39626, 39620},
        DRUID = {39546, 39539, 39555},
        MAGE = {39493},
        ROGUE = {39564},
    },
    [40622] = { -- Spaulders of the Lost Conqueror
        PALADIN = {39642, 39637, 39631},
        PRIEST = {39529, 39518},
        WARLOCK = {39499},
    },
    [40623] = { -- Spaulders of the Lost Protector
        HUNTER = {39581},
        SHAMAN = {39604, 39596, 39590},
        WARRIOR = {39608, 39613},
    },
    [40624] = { -- Spaulders of the Lost Vanquisher
        DEATHKNIGHT = {39627, 39621},
        DRUID = {39556, 39548, 39542},
        MAGE = {39494},
        ROGUE = {39565},
    },
    [40625] = { -- Breastplate of the Lost Conqueror
        PALADIN = {40569, 40579, 40574},
        PRIEST = {40449, 40458},
        WARLOCK = {40423},
    },
    [40626] = { -- Breastplate of the Lost Protector
        HUNTER = {40503},
        SHAMAN = {40514, 40523, 40508},
        WARRIOR = {40544, 40525},
    },
    [40627] = { -- Breastplate of the Lost Vanquisher
        DEATHKNIGHT = {40550, 40559},
        DRUID = {40471, 40469, 40463},
        MAGE = {40418},
        ROGUE = {40495},
    },
    [40628] = { -- Gauntlets of the Lost Conqueror
        PALADIN = {40570, 40580, 40575},
        PRIEST = {40445, 40454},
        WARLOCK = {40420},
    },
    [40629] = { -- Gauntlets of the Lost Protector
        HUNTER = {40504},
        SHAMAN = {40520, 40515, 40509},
        WARRIOR = {40545, 40527},
    },
    [40630] = { -- Gauntlets of the Lost Vanquisher
        DEATHKNIGHT = {40552, 40563},
        DRUID = {40472, 40466, 40460},
        MAGE = {40415},
        ROGUE = {40496},
    },
    [40631] = { -- Crown of the Lost Conqueror
        PALADIN = {40576, 40571, 40581},
        PRIEST = {40456, 40447},
        WARLOCK = {40421},
    },
    [40632] = { -- Crown of the Lost Protector
        HUNTER = {40505},
        SHAMAN = {40521, 40516, 40510},
        WARRIOR = {40528, 40546},
    },
    [40633] = { -- Crown of the Lost Vanquisher
        DEATHKNIGHT = {40554, 40565},
        DRUID = {40473, 40467, 40461},
        MAGE = {40416},
        ROGUE = {40499},
    },
    [40634] = { -- Legplates of the Lost Conqueror
        PALADIN = {40577, 40572, 40583},
        PRIEST = {40448, 40457},
        WARLOCK = {40422},
    },
    [40635] = { -- Legplates of the Lost Protector
        HUNTER = {40506},
        SHAMAN = {40512, 40522, 40517},
        WARRIOR = {40529, 40547},
    },
    [40636] = { -- Legplates of the Lost Vanquisher
        DEATHKNIGHT = {40556, 40567},
        DRUID = {40468, 40493, 40462},
        MAGE = {40417},
        ROGUE = {40500},
    },
    [40637] = { -- Mantle of the Lost Conqueror
        PALADIN = {40584, 40578, 40573},
        PRIEST = {40450, 40459},
        WARLOCK = {40424},
    },
    [40638] = { -- Mantle of the Lost Protector
        HUNTER = {40507},
        SHAMAN = {40513, 40524, 40518},
        WARRIOR = {40530, 40548},
    },
    [40639] = { -- Mantle of the Lost Vanquisher
        DEATHKNIGHT = {40568, 40557},
        DRUID = {40494, 40465, 40470},
        MAGE = {40419},
        ROGUE = {40502},
    },
    [45632] = { -- Breastplate of the Wayward Conqueror
        PALADIN = {46154, 46173, 46178},
        PRIEST = {46168, 46193},
        WARLOCK = {46137},
    },
    [45633] = { -- Breastplate of the Wayward Protector
        HUNTER = {46141},
        SHAMAN = {46206, 46205, 46198},
        WARRIOR = {46146, 46162},
    },
    [45634] = { -- Breastplate of the Wayward Vanquisher
        DEATHKNIGHT = {46118, 46111},
        DRUID = {46186, 46194, 46159},
        MAGE = {46130},
        ROGUE = {46123},
    },
    [45635] = { -- Chestguard of the Wayward Conqueror
        PALADIN = {45381, 45374, 45375},
        PRIEST = {45395, 45389},
        WARLOCK = {45421},
    },
    [45636] = { -- Chestguard of the Wayward Protector
        HUNTER = {45364},
        SHAMAN = {45411, 45405, 45413},
        WARRIOR = {45424, 45429},
    },
    [45637] = { -- Chestguard of the Wayward Vanquisher
        DEATHKNIGHT = {45340, 45335},
        DRUID = {45354, 45348, 45358},
        MAGE = {45368},
        ROGUE = {45396},
    },
    [45638] = { -- Crown of the Wayward Conqueror
        PALADIN = {46180, 46156, 46175},
        PRIEST = {46172, 46197},
        WARLOCK = {46140},
    },
    [45639] = { -- Crown of the Wayward Protector
        HUNTER = {46143},
        SHAMAN = {46209, 46201, 46212},
        WARRIOR = {46166, 46151},
    },
    [45640] = { -- Crown of the Wayward Vanquisher
        DEATHKNIGHT = {46120, 46115},
        DRUID = {46184, 46161, 46191},
        MAGE = {46129},
        ROGUE = {46125},
    },
    [45641] = { -- Gauntlets of the Wayward Conqueror
        PALADIN = {46155, 46179, 46174},
        PRIEST = {46163, 46188},
        WARLOCK = {46135},
    },
    [45642] = { -- Gauntlets of the Wayward Protector
        HUNTER = {46142},
        SHAMAN = {46200, 46207, 46199},
        WARRIOR = {46148, 46164},
    },
    [45643] = { -- Gauntlets of the Wayward Vanquisher
        DEATHKNIGHT = {46113, 46119},
        DRUID = {46189, 46158, 46183},
        MAGE = {46132},
        ROGUE = {46124},
    },
    [45644] = { -- Gloves of the Wayward Conqueror
        PALADIN = {45376, 45370, 45383},
        PRIEST = {45392, 45387},
        WARLOCK = {45419},
    },
    [45645] = { -- Gloves of the Wayward Protector
        HUNTER = {45360},
        SHAMAN = {45401, 45414, 45406},
        WARRIOR = {45426, 45430},
    },
    [45646] = { -- Gloves of the Wayward Vanquisher
        DEATHKNIGHT = {45337, 45341},
        DRUID = {45345, 45355, 45351},
        MAGE = {46131},
        ROGUE = {45397},
    },
    [45647] = { -- Helm of the Wayward Conqueror
        PALADIN = {45377, 45372, 45382},
        PRIEST = {45386, 45391},
        WARLOCK = {45417},
    },
    [45648] = { -- Helm of the Wayward Protector
        HUNTER = {45361},
        SHAMAN = {45408, 45402, 45412},
        WARRIOR = {45425, 45431},
    },
    [45649] = { -- Helm of the Wayward Vanquisher
        DEATHKNIGHT = {45336, 45342},
        DRUID = {46313, 45346, 45356},
        MAGE = {45365},
        ROGUE = {45398},
    },
    [45650] = { -- Leggings of the Wayward Conqueror
        PALADIN = {45384, 45379, 45371},
        PRIEST = {45394, 45388},
        WARLOCK = {45420},
    },
    [45651] = { -- Leggings of the Wayward Protector
        HUNTER = {45362},
        SHAMAN = {45416, 45409, 45403},
        WARRIOR = {45432, 45427},
    },
    [45652] = { -- Leggings of the Wayward Vanquisher
        DEATHKNIGHT = {45338, 45343},
        DRUID = {45353, 45347, 45357},
        MAGE = {45367},
        ROGUE = {45399},
    },
    [45653] = { -- Legplates of the Wayward Conqueror
        PALADIN = {46176, 46153, 46181},
        PRIEST = {46170, 46195},
        WARLOCK = {46139},
    },
    [45654] = { -- Legplates of the Wayward Protector
        HUNTER = {46144},
        SHAMAN = {46208, 46210, 46202},
        WARRIOR = {46169, 46150},
    },
    [45655] = { -- Legplates of the Wayward Vanquisher
        DEATHKNIGHT = {46121, 46116},
        DRUID = {46192, 46185, 46160},
        MAGE = {46133},
        ROGUE = {46126},
    },
    [45656] = { -- Mantle of the Wayward Conqueror
        PALADIN = {46152, 46177, 46182},
        PRIEST = {46165, 46190},
        WARLOCK = {46136},
    },
    [45657] = { -- Mantle of the Wayward Protector
        HUNTER = {46145},
        SHAMAN = {46211, 46204, 46203},
        WARRIOR = {46149, 46167},
    },
    [45658] = { -- Mantle of the Wayward Vanquisher
        DEATHKNIGHT = {46122, 46117},
        DRUID = {46187, 46196, 46157},
        MAGE = {46134},
        ROGUE = {46127},
    },
    [45659] = { -- Spaulders of the Wayward Conqueror
        PALADIN = {45385, 45380, 45373},
        PRIEST = {45393, 45390},
        WARLOCK = {45422},
    },
    [45660] = { -- Spaulders of the Wayward Protector
        HUNTER = {45363},
        SHAMAN = {45410, 45404, 45415},
        WARRIOR = {45433, 45428},
    },
    [45661] = { -- Spaulders of the Wayward Vanquisher
        DEATHKNIGHT = {45344, 45339},
        DRUID = {45352, 45349, 45359},
        MAGE = {45369},
        ROGUE = {45400},
    },
    [47242] = { -- Trophy of the Crusade
        DEATHKNIGHT = {48481, 48482, 48483, 48484, 48485, 48553, 48554, 48555, 48556, 48557, 48496, 48497, 48498, 48499, 48500, 48538, 48539, 48540, 48541, 48542},
        DRUID = {48133, 48134, 48135, 48136, 48137, 48148, 48149, 48150, 48151, 48152, 48163, 48164, 48165, 48166, 48167, 48178, 48179, 48180, 48181, 48182, 48193, 48194, 48195, 48196, 48197, 48208, 48209, 48210, 48211, 48212},
        HUNTER = {48256, 48257, 48258, 48259, 48270, 48271, 48272, 48273, 48274, 48255},
        MAGE = {47753, 47754, 47755, 47756, 47757, 47768, 47769, 47770, 47771, 47772},
        PALADIN = {48640, 48641, 48657, 48658, 48659, 48660, 48661, 48575, 48576, 48577, 48578, 48579, 48590, 48591, 48592, 48593, 48594, 48607, 48608, 48609, 48610, 48611, 48622, 48623, 48624, 48625, 48626, 48637, 48638, 48639},
        PRIEST = {48096, 48064, 48065, 48066, 48077, 48078, 48079, 48080, 48081, 47983, 47984, 48062, 47985, 47986, 47987, 48063, 48092, 48093, 48094, 48095},
        ROGUE = {48224, 48225, 48226, 48227, 48238, 48239, 48240, 48241, 48242, 48223},
        SHAMAN = {48285, 48286, 48287, 48288, 48289, 48300, 48301, 48302, 48303, 48304, 48316, 48317, 48318, 48319, 48320, 48331, 48332, 48333, 48334, 48335, 48346, 48347, 48348, 48349, 48350, 48361, 48362, 48363, 48364, 48365},
        WARLOCK = {47778, 47779, 47780, 47781, 47782, 47803, 47804, 47805, 47806, 47807},
        WARRIOR = {48450, 48452, 48454, 48391, 48392, 48393, 48394, 48395, 48461, 48462, 48430, 48463, 48464, 48465, 48376, 48377, 48378, 48379, 48380, 48446},
    },
    [47557] = { -- Regalia of the Grand Conqueror
        PALADIN = {48642, 48643, 48644, 48645, 48646, 48647, 48648, 48649, 48650, 48651, 48580, 48581, 48582, 48583, 48584, 48585, 48586, 48587, 48588, 48589, 48612, 48613, 48614, 48615, 48616, 48617, 48618, 48619, 48620, 48621},
        PRIEST = {48058, 48033, 48035, 48037, 48091, 48029, 48082, 48083, 48084, 48085, 48086, 48087, 48088, 48089, 48090, 48059, 48060, 48061, 48057, 48031},
        WARLOCK = {47788, 47789, 47790, 47791, 47792, 47793, 47794, 47795, 47796, 47797},
    },
    [47558] = { -- Regalia of the Grand Protector
        HUNTER = {48260, 48261, 48262, 48263, 48264, 48265, 48266, 48267, 48268, 48269},
        SHAMAN = {48290, 48291, 48292, 48293, 48294, 48305, 48306, 48307, 48308, 48309, 48321, 48322, 48323, 48324, 48325, 48326, 48327, 48328, 48329, 48330, 48351, 48352, 48353, 48354, 48355, 48356, 48357, 48358, 48359, 48360},
        WARRIOR = {48384, 48385, 48451, 48447, 48453, 48455, 48396, 48397, 48398, 48399, 48400, 48433, 48466, 48467, 48468, 48469, 48470, 48381, 48382, 48383},
    },
    [47559] = { -- Regalia of the Grand Vanquisher
        DEATHKNIGHT = {48544, 48545, 48546, 48547, 48548, 48549, 48550, 48551, 48552, 48486, 48487, 48488, 48489, 48493, 48494, 48495, 48491, 48490, 48492, 48543},
        DRUID = {48138, 48139, 48140, 48141, 48142, 48143, 48144, 48145, 48146, 48147, 48168, 48169, 48170, 48171, 48172, 48173, 48174, 48175, 48176, 48177, 48198, 48199, 48200, 48201, 48202, 48203, 48204, 48205, 48206, 48207},
        MAGE = {47758, 47759, 47760, 47761, 47762, 47763, 47764, 47765, 47766, 47767},
        ROGUE = {48228, 48229, 48230, 48231, 48232, 48233, 48234, 48235, 48236, 48237},
    },
    [52025] = { -- Vanquisher's Mark of Sanctification
        DEATHKNIGHT = {51125, 51126, 51127, 51128, 51129, 51130, 51131, 51132, 51133, 51134},
        DRUID = {51136, 51137, 51138, 51139, 51140, 51141, 51142, 51143, 51144, 51145, 51146, 51147, 51148, 51149, 51135},
        MAGE = {51155, 51156, 51157, 51158, 51159},
        ROGUE = {51185, 51186, 51187, 51188, 51189},
    },
    [52026] = { -- Protector's Mark of Sanctification
        HUNTER = {51152, 51153, 51154, 51150, 51151},
        SHAMAN = {51200, 51201, 51202, 51203, 51204, 51190, 51191, 51192, 51193, 51194, 51195, 51196, 51197, 51198, 51199},
        WARRIOR = {51210, 51211, 51212, 51213, 51214, 51215, 51216, 51217, 51218, 51219},
    },
    [52027] = { -- Conqueror's Mark of Sanctification
        PALADIN = {51168, 51169, 51170, 51171, 51172, 51173, 51174, 51160, 51161, 51162, 51163, 51164, 51165, 51166, 51167},
        PRIEST = {51175, 51176, 51177, 51178, 51179, 51180, 51181, 51182, 51183, 51184},
        WARLOCK = {51208, 51209, 51205, 51206, 51207},
    },
    [52028] = { -- Vanquisher's Mark of Sanctification
        DEATHKNIGHT = {51305, 51306, 51307, 51308, 51309, 51310, 51311, 51312, 51313, 51314},
        DRUID = {51296, 51297, 51298, 51299, 51300, 51301, 51302, 51303, 51304, 51290, 51291, 51292, 51293, 51294, 51295},
        MAGE = {51280, 51281, 51282, 51283, 51284},
        ROGUE = {51250, 51251, 51252, 51253, 51254},
    },
    [52029] = { -- Protector's Mark of Sanctification
        HUNTER = {51288, 51289, 51285, 51286, 51287},
        SHAMAN = {51235, 51236, 51237, 51238, 51239, 51240, 51241, 51242, 51243, 51244, 51245, 51246, 51247, 51248, 51249},
        WARRIOR = {51220, 51221, 51222, 51223, 51224, 51225, 51226, 51227, 51228, 51229},
    },
    [52030] = { -- Conqueror's Mark of Sanctification
        PALADIN = {51265, 51266, 51267, 51268, 51269, 51270, 51271, 51272, 51273, 51274, 51275, 51276, 51277, 51278, 51279},
        PRIEST = {51264, 51255, 51256, 51257, 51258, 51259, 51260, 51261, 51262, 51263},
        WARLOCK = {51232, 51233, 51234, 51230, 51231},
    },
    [65000] = { -- Crown of the Forlorn Protector
        HUNTER = {65206},
        SHAMAN = {65256, 65251, 65246},
        WARRIOR = {65266, 65271},
    },
    [65001] = { -- Crown of the Forlorn Conqueror
        PALADIN = {65216, 65226, 65221},
        PRIEST = {65235, 65230},
        WARLOCK = {65260},
    },
    [65002] = { -- Crown of the Forlorn Vanquisher
        DEATHKNIGHT = {65186, 65181},
        DRUID = {65200, 65195, 65190},
        MAGE = {65210},
        ROGUE = {65241},
    },
    [65087] = { -- Shoulders of the Forlorn Protector
        HUNTER = {65208},
        SHAMAN = {65248, 65258, 65253},
        WARRIOR = {65273, 65268},
    },
    [65088] = { -- Shoulders of the Forlorn Conqueror
        PALADIN = {65218, 65228, 65223},
        PRIEST = {65233, 65238},
        WARLOCK = {65263},
    },
    [65089] = { -- Shoulders of the Forlorn Vanquisher
        DEATHKNIGHT = {65188, 65183},
        DRUID = {65193, 65203, 65198},
        MAGE = {65213},
        ROGUE = {65243},
    },
    [67423] = { -- Chest of the Forlorn Conqueror
        PALADIN = {65224, 65219, 65214},
        PRIEST = {65232, 65237},
        WARLOCK = {65262},
    },
    [67424] = { -- Chest of the Forlorn Protector
        HUNTER = {65204},
        SHAMAN = {65249, 65244, 65254},
        WARRIOR = {65264, 65269},
    },
    [67425] = { -- Chest of the Forlorn Vanquisher
        DEATHKNIGHT = {65184, 65179},
        DRUID = {65192, 65202, 65197},
        MAGE = {65212},
        ROGUE = {65239},
    },
    [67426] = { -- Leggings of the Forlorn Vanquisher
        DEATHKNIGHT = {65187, 65182},
        DRUID = {65201, 65196, 65191},
        MAGE = {65211},
        ROGUE = {65242},
    },
    [67427] = { -- Leggings of the Forlorn Protector
        HUNTER = {65207},
        SHAMAN = {65257, 65252, 65247},
        WARRIOR = {65272, 65267},
    },
    [67428] = { -- Leggings of the Forlorn Conqueror
        PALADIN = {65217, 65227, 65222},
        PRIEST = {65236, 65231},
        WARLOCK = {65261},
    },
    [67429] = { -- Gauntlets of the Forlorn Conqueror
        PALADIN = {65225, 65220, 65215},
        PRIEST = {65234, 65229},
        WARLOCK = {65259},
    },
    [67430] = { -- Gauntlets of the Forlorn Protector
        HUNTER = {65205},
        SHAMAN = {65250, 65245, 65255},
        WARRIOR = {65265, 65270},
    },
    [67431] = { -- Gauntlets of the Forlorn Vanquisher
        DEATHKNIGHT = {65185, 65180},
        DRUID = {65194, 65189, 65199},
        MAGE = {65209},
        ROGUE = {65240},
    },
    [71669] = { -- Gauntlets of the Fiery Vanquisher
        DEATHKNIGHT = {71482, 71477},
        DRUID = {71496, 71491, 71487},
        MAGE = {71507},
        ROGUE = {71538},
    },
    [71670] = { -- Crown of the Fiery Vanquisher
        DEATHKNIGHT = {71483, 71478},
        DRUID = {71488, 71497, 71492},
        MAGE = {71508},
        ROGUE = {71539},
    },
    [71671] = { -- Leggings of the Fiery Vanquisher
        DEATHKNIGHT = {71484, 71479},
        DRUID = {71489, 71498, 71493},
        MAGE = {71509},
        ROGUE = {71540},
    },
    [71672] = { -- Chest of the Fiery Vanquisher
        DEATHKNIGHT = {71481, 71476},
        DRUID = {71486, 71499, 71494},
        MAGE = {71510},
        ROGUE = {71537},
    },
    [71673] = { -- Shoulders of the Fiery Vanquisher
        DEATHKNIGHT = {71480, 71485},
        DRUID = {71490, 71500, 71495},
        MAGE = {71511},
        ROGUE = {71541},
    },
    [71676] = { -- Gauntlets of the Fiery Conqueror
        PALADIN = {71513, 71523, 71518},
        PRIEST = {71532, 71527},
        WARLOCK = {71594},
    },
    [71677] = { -- Crown of the Fiery Conqueror
        PALADIN = {71514, 71524, 71519},
        PRIEST = {71528, 71533},
        WARLOCK = {71595},
    },
    [71678] = { -- Leggings of the Fiery Conqueror
        PALADIN = {71520, 71515, 71525},
        PRIEST = {71529, 71534},
        WARLOCK = {71596},
    },
    [71679] = { -- Chest of the Fiery Conqueror
        PALADIN = {71512, 71522, 71517},
        PRIEST = {71530, 71535},
        WARLOCK = {71597},
    },
    [71680] = { -- Shoulders of the Fiery Conqueror
        PALADIN = {71521, 71516, 71526},
        PRIEST = {71536, 71531},
        WARLOCK = {71598},
    },
    [71683] = { -- Gauntlets of the Fiery Protector
        HUNTER = {71502},
        SHAMAN = {71553, 71548, 71543},
        WARRIOR = {71601, 71605},
    },
    [71684] = { -- Crown of the Fiery Protector
        HUNTER = {71503},
        SHAMAN = {71544, 71554, 71549},
        WARRIOR = {71606, 71599},
    },
    [71685] = { -- Leggings of the Fiery Protector
        HUNTER = {71504},
        SHAMAN = {71545, 71555, 71550},
        WARRIOR = {71602, 71607},
    },
    [71686] = { -- Chest of the Fiery Protector
        HUNTER = {71501},
        SHAMAN = {71552, 71547, 71542},
        WARRIOR = {71600, 71604},
    },
    [71687] = { -- Shoulders of the Fiery Protector
        HUNTER = {71505},
        SHAMAN = {71546, 71556, 71551},
        WARRIOR = {71608, 71603},
    },
    [78170] = { -- Shoulders of the Corrupted Vanquisher
        DEATHKNIGHT = {76978, 77012},
        DRUID = {76753, 77017, 77022},
        MAGE = {76216},
        ROGUE = {77027},
    },
    [78171] = { -- Leggings of the Corrupted Vanquisher
        DEATHKNIGHT = {76977, 77011},
        DRUID = {77016, 77020, 76751},
        MAGE = {76214},
        ROGUE = {77026},
    },
    [78172] = { -- Crown of the Corrupted Vanquisher
        DEATHKNIGHT = {76976, 77010},
        DRUID = {77019, 76750, 77015},
        MAGE = {76213},
        ROGUE = {77025},
    },
    [78173] = { -- Gauntlets of the Corrupted Vanquisher
        DEATHKNIGHT = {77009, 76975},
        DRUID = {77018, 76749, 77014},
        MAGE = {76212},
        ROGUE = {77024},
    },
    [78174] = { -- Chest of the Corrupted Vanquisher
        DEATHKNIGHT = {77008, 76974},
        DRUID = {76752, 77021, 77013},
        MAGE = {76215},
        ROGUE = {77023},
    },
    [78175] = { -- Shoulders of the Corrupted Protector
        HUNTER = {77032},
        SHAMAN = {76760, 77035, 77044},
        WARRIOR = {76992, 76987},
    },
    [78176] = { -- Leggings of the Corrupted Protector
        HUNTER = {77031},
        SHAMAN = {77043, 77036, 76759},
        WARRIOR = {76986, 76991},
    },
    [78177] = { -- Crown of the Corrupted Protector
        HUNTER = {77030},
        SHAMAN = {77042, 77037, 76758},
        WARRIOR = {76990, 76983},
    },
    [78178] = { -- Gauntlets of the Corrupted Protector
        HUNTER = {77029},
        SHAMAN = {77041, 76757, 77038},
        WARRIOR = {76985, 76989},
    },
    [78179] = { -- Chest of the Corrupted Protector
        HUNTER = {77028},
        SHAMAN = {77040, 76756, 77039},
        WARRIOR = {76984, 76988},
    },
    [78180] = { -- Shoulders of the Corrupted Conqueror
        PALADIN = {76769, 76878, 77007},
        PRIEST = {76344, 76361},
        WARLOCK = {76339},
    },
    [78181] = { -- Leggings of the Corrupted Conqueror
        PALADIN = {76768, 76877, 77006},
        PRIEST = {76346, 76359},
        WARLOCK = {76341},
    },
    [78182] = { -- Crown of the Corrupted Conqueror
        PALADIN = {76876, 77005, 76767},
        PRIEST = {76347, 76358},
        WARLOCK = {76342},
    },
    [78183] = { -- Gauntlets of the Corrupted Conqueror
        PALADIN = {76875, 77004, 76766},
        PRIEST = {76348, 76357},
        WARLOCK = {76343},
    },
    [78184] = { -- Chest of the Corrupted Conqueror
        PALADIN = {76874, 77003, 76765},
        PRIEST = {76360, 76345},
        WARLOCK = {76340},
    },
    [78847] = { -- Chest of the Corrupted Conqueror
        PALADIN = {78732, 78726, 78727},
        PRIEST = {78728, 78731},
        WARLOCK = {78730},
    },
    [78848] = { -- Chest of the Corrupted Protector
        HUNTER = {78661},
        SHAMAN = {78723, 78724, 78725},
        WARRIOR = {78657, 78658},
    },
    [78849] = { -- Chest of the Corrupted Vanquisher
        DEATHKNIGHT = {78659, 78663},
        DRUID = {78665, 78660, 78662},
        MAGE = {78729},
        ROGUE = {78664},
    },
    [78850] = { -- Crown of the Corrupted Conqueror
        PALADIN = {78692, 78693, 78695},
        PRIEST = {78700, 78703},
        WARLOCK = {78702},
    },
    [78851] = { -- Crown of the Corrupted Protector
        HUNTER = {78698},
        SHAMAN = {78691, 78685, 78686},
        WARRIOR = {78688, 78689},
    },
    [78852] = { -- Crown of the Corrupted Vanquisher
        DEATHKNIGHT = {78697, 78687},
        DRUID = {78696, 78690, 78694},
        MAGE = {78701},
        ROGUE = {78699},
    },
    [78853] = { -- Gauntlets of the Corrupted Conqueror
        PALADIN = {78673, 78675, 78677},
        PRIEST = {78682, 78683},
        WARLOCK = {78681},
    },
    [78854] = { -- Gauntlets of the Corrupted Protector
        HUNTER = {78674},
        SHAMAN = {78672, 78666, 78667},
        WARRIOR = {78668, 78669},
    },
    [78855] = { -- Gauntlets of the Corrupted Vanquisher
        DEATHKNIGHT = {78678, 78670},
        DRUID = {78680, 78676, 78684},
        MAGE = {78671},
        ROGUE = {78679},
    },
    [78856] = { -- Leggings of the Corrupted Conqueror
        PALADIN = {78712, 78715, 78717},
        PRIEST = {78722, 78719},
        WARLOCK = {78721},
    },
    [78857] = { -- Leggings of the Corrupted Protector
        HUNTER = {78709},
        SHAMAN = {78704, 78718, 78711},
        WARRIOR = {78705, 78706},
    },
    [78858] = { -- Leggings of the Corrupted Vanquisher
        DEATHKNIGHT = {78707, 78716},
        DRUID = {78713, 78714, 78710},
        MAGE = {78720},
        ROGUE = {78708},
    },
    [78859] = { -- Shoulders of the Corrupted Conqueror
        PALADIN = {78745, 78746, 78742},
        PRIEST = {78747, 78750},
        WARLOCK = {78749},
    },
    [78860] = { -- Shoulders of the Corrupted Protector
        HUNTER = {78737},
        SHAMAN = {78739, 78733, 78741},
        WARRIOR = {78734, 78735},
    },
    [78861] = { -- Shoulders of the Corrupted Vanquisher
        DEATHKNIGHT = {78736, 78751},
        DRUID = {78744, 78740, 78743},
        MAGE = {78748},
        ROGUE = {78738},
    },
    [78862] = { -- Chest of the Corrupted Vanquisher
        DEATHKNIGHT = {78754, 78758},
        DRUID = {78760, 78755, 78757},
        MAGE = {78824},
        ROGUE = {78759},
    },
    [78863] = { -- Chest of the Corrupted Conqueror
        PALADIN = {78827, 78821, 78822},
        PRIEST = {78826, 78823},
        WARLOCK = {78825},
    },
    [78864] = { -- Chest of the Corrupted Protector
        HUNTER = {78756},
        SHAMAN = {78818, 78819, 78820},
        WARRIOR = {78752, 78753},
    },
    [78865] = { -- Gauntlets of the Corrupted Vanquisher
        DEATHKNIGHT = {78773, 78765},
        DRUID = {78779, 78771, 78775},
        MAGE = {78766},
        ROGUE = {78774},
    },
    [78866] = { -- Gauntlets of the Corrupted Conqueror
        PALADIN = {78768, 78770, 78772},
        PRIEST = {78777, 78778},
        WARLOCK = {78776},
    },
    [78867] = { -- Gauntlets of the Corrupted Protector
        HUNTER = {78769},
        SHAMAN = {78761, 78762, 78767},
        WARRIOR = {78763, 78764},
    },
    [78868] = { -- Crown of the Corrupted Vanquisher
        DEATHKNIGHT = {78792, 78782},
        DRUID = {78785, 78789, 78791},
        MAGE = {78796},
        ROGUE = {78794},
    },
    [78869] = { -- Crown of the Corrupted Conqueror
        PALADIN = {78787, 78788, 78790},
        PRIEST = {78795, 78798},
        WARLOCK = {78797},
    },
    [78870] = { -- Crown of the Corrupted Protector
        HUNTER = {78793},
        SHAMAN = {78786, 78780, 78781},
        WARRIOR = {78784, 78783},
    },
    [78871] = { -- Leggings of the Corrupted Vanquisher
        DEATHKNIGHT = {78802, 78811},
        DRUID = {78808, 78809, 78805},
        MAGE = {78815},
        ROGUE = {78803},
    },
    [78872] = { -- Leggings of the Corrupted Conqueror
        PALADIN = {78810, 78812, 78807},
        PRIEST = {78817, 78814},
        WARLOCK = {78816},
    },
    [78873] = { -- Leggings of the Corrupted Protector
        HUNTER = {78804},
        SHAMAN = {78813, 78806, 78799},
        WARRIOR = {78800, 78801},
    },
    [78874] = { -- Shoulders of the Corrupted Vanquisher
        DEATHKNIGHT = {78846, 78831},
        DRUID = {78835, 78838, 78839},
        MAGE = {78843},
        ROGUE = {78833},
    },
    [78875] = { -- Shoulders of the Corrupted Conqueror
        PALADIN = {78840, 78841, 78837},
        PRIEST = {78842, 78845},
        WARLOCK = {78844},
    },
    [78876] = { -- Shoulders of the Corrupted Protector
        HUNTER = {78832},
        SHAMAN = {78836, 78834, 78828},
        WARRIOR = {78829, 78830},
    },
    [89234] = { -- Helm of the Shadowy Vanquisher
        DEATHKNIGHT = {85336, 85316},
        DRUID = {85307, 85357, 85381, 85311},
        MAGE = {85377},
        ROGUE = {85301},
    },
    [89235] = { -- Helm of the Shadowy Conqueror
        PALADIN = {85321, 85346, 85341},
        PRIEST = {85362, 85365},
        WARLOCK = {85370},
    },
    [89236] = { -- Helm of the Shadowy Protector
        HUNTER = {85296},
        MONK = {85386, 85396, 85390},
        SHAMAN = {85291, 85286, 85351},
        WARRIOR = {85333, 85326},
    },
    [89237] = { -- Chest of the Shadowy Conqueror
        PALADIN = {85323, 85348, 85343},
        PRIEST = {85360, 85367},
        WARLOCK = {85372},
    },
    [89238] = { -- Chest of the Shadowy Protector
        HUNTER = {85298},
        MONK = {85392, 85394, 85388},
        SHAMAN = {85288, 85289, 85353},
        WARRIOR = {85328, 85332},
    },
    [89239] = { -- Chest of the Shadowy Vanquisher
        DEATHKNIGHT = {85338, 85318},
        DRUID = {85313, 85305, 85355, 85379},
        MAGE = {85375},
        ROGUE = {85303},
    },
    [89240] = { -- Gauntlets of the Shadowy Conqueror
        PALADIN = {85322, 85347, 85342},
        PRIEST = {85363, 85364},
        WARLOCK = {85369},
    },
    [89241] = { -- Gauntlets of the Shadowy Protector
        HUNTER = {85297},
        MONK = {85395, 85387, 85389},
        SHAMAN = {85352, 85290, 85287},
        WARRIOR = {85331, 85327},
    },
    [89242] = { -- Gauntlets of the Shadowy Vanquisher
        DEATHKNIGHT = {85337, 85317},
        DRUID = {85312, 85380, 85308, 85358},
        MAGE = {85378},
        ROGUE = {85302},
    },
    [89243] = { -- Leggings of the Shadowy Conqueror
        PALADIN = {85320, 85345, 85340},
        PRIEST = {85361, 85366},
        WARLOCK = {85371},
    },
    [89244] = { -- Leggings of the Shadowy Protector
        HUNTER = {85295},
        MONK = {85385, 85397, 85391},
        SHAMAN = {85292, 85285, 85350},
        WARRIOR = {85330, 85325},
    },
    [89245] = { -- Leggings of the Shadowy Vanquisher
        DEATHKNIGHT = {85315, 85335},
        DRUID = {85306, 85382, 85356, 85310},
        MAGE = {85376},
        ROGUE = {85300},
    },
    [89246] = { -- Shoulders of the Shadowy Conqueror
        PALADIN = {85344, 85339, 85319},
        PRIEST = {85368, 85359},
        WARLOCK = {85373},
    },
    [89247] = { -- Shoulders of the Shadowy Protector
        HUNTER = {85294},
        MONK = {85384, 85393, 85398},
        SHAMAN = {85349, 85284, 85293},
        WARRIOR = {85329, 85324},
    },
    [89248] = { -- Shoulders of the Shadowy Vanquisher
        DEATHKNIGHT = {85314, 85334},
        DRUID = {85304, 85354, 85309, 85383},
        MAGE = {85374},
        ROGUE = {85299},
    },
    [89249] = { -- Chest of the Shadowy Vanquisher
        DEATHKNIGHT = {86913, 86918},
        DRUID = {86936, 86938, 86923, 86931},
        MAGE = {87010},
        ROGUE = {87124},
    },
    [89250] = { -- Chest of the Shadowy Conqueror
        PALADIN = {87104, 87099, 87109},
        PRIEST = {87122, 87117},
        WARLOCK = {87190},
    },
    [89251] = { -- Chest of the Shadowy Protector
        HUNTER = {87002},
        MONK = {87094, 87084, 87092},
        SHAMAN = {87129, 87139, 87134},
        WARRIOR = {87193, 87197},
    },
    [89252] = { -- Leggings of the Shadowy Vanquisher
        DEATHKNIGHT = {86921, 86916},
        DRUID = {86930, 86941, 86926, 86935},
        MAGE = {87009},
        ROGUE = {87127},
    },
    [89253] = { -- Leggings of the Shadowy Conqueror
        PALADIN = {87112, 87107, 87102},
        PRIEST = {87121, 87116},
        WARLOCK = {87189},
    },
    [89254] = { -- Leggings of the Shadowy Protector
        HUNTER = {87005},
        MONK = {87097, 87091, 87087},
        SHAMAN = {87137, 87132, 87142},
        WARRIOR = {87200, 87195},
    },
    [89255] = { -- Gauntlets of the Shadowy Vanquisher
        DEATHKNIGHT = {86914, 86919},
        DRUID = {86928, 86939, 86924, 86933},
        MAGE = {87007},
        ROGUE = {87125},
    },
    [89256] = { -- Gauntlets of the Shadowy Conqueror
        PALADIN = {87105, 87100, 87110},
        PRIEST = {87114, 87119},
        WARLOCK = {87187},
    },
    [89257] = { -- Gauntlets of the Shadowy Protector
        HUNTER = {87003},
        MONK = {87089, 87085, 87095},
        SHAMAN = {87130, 87140, 87135},
        WARRIOR = {87194, 87198},
    },
    [89258] = { -- Helm of the Shadowy Vanquisher
        DEATHKNIGHT = {86920, 86915},
        DRUID = {86929, 86940, 86925, 86934},
        MAGE = {87008},
        ROGUE = {87126},
    },
    [89259] = { -- Helm of the Shadowy Conqueror
        PALADIN = {87106, 87101, 87111},
        PRIEST = {87120, 87115},
        WARLOCK = {87188},
    },
    [89260] = { -- Helm of the Shadowy Protector
        HUNTER = {87004},
        MONK = {87096, 87090, 87086},
        SHAMAN = {87136, 87131, 87141},
        WARRIOR = {87192, 87199},
    },
    [89261] = { -- Shoulders of the Shadowy Vanquisher
        DEATHKNIGHT = {86922, 86917},
        DRUID = {86937, 86932, 86942, 86927},
        MAGE = {87011},
        ROGUE = {87128},
    },
    [89262] = { -- Shoulders of the Shadowy Conqueror
        PALADIN = {87113, 87108, 87103},
        PRIEST = {87123, 87118},
        WARLOCK = {87191},
    },
    [89263] = { -- Shoulders of the Shadowy Protector
        HUNTER = {87006},
        MONK = {87088, 87098, 87093},
        SHAMAN = {87138, 87133, 87143},
        WARRIOR = {87201, 87196},
    },
    [89264] = { -- Chest of the Shadowy Vanquisher
        DEATHKNIGHT = {86658, 86678},
        DRUID = {86719, 86645, 86653, 86695},
        MAGE = {86715},
        ROGUE = {86643},
    },
    [89265] = { -- Chest of the Shadowy Conqueror
        PALADIN = {86688, 86683, 86663},
        PRIEST = {86707, 86700},
        WARLOCK = {86712},
    },
    [89266] = { -- Chest of the Shadowy Protector
        HUNTER = {86638},
        MONK = {86728, 86732, 86734},
        SHAMAN = {86628, 86629, 86693},
        WARRIOR = {86672, 86668},
    },
    [89267] = { -- Leggings of the Shadowy Vanquisher
        DEATHKNIGHT = {86675, 86655},
        DRUID = {86696, 86722, 86650, 86646},
        MAGE = {86716},
        ROGUE = {86640},
    },
    [89268] = { -- Leggings of the Shadowy Conqueror
        PALADIN = {86680, 86660, 86685},
        PRIEST = {86706, 86701},
        WARLOCK = {86711},
    },
    [89269] = { -- Leggings of the Shadowy Protector
        HUNTER = {86635},
        MONK = {86737, 86731, 86725},
        SHAMAN = {86632, 86625, 86690},
        WARRIOR = {86665, 86670},
    },
    [89270] = { -- Gauntlets of the Shadowy Vanquisher
        DEATHKNIGHT = {86657, 86677},
        DRUID = {86648, 86698, 86652, 86720},
        MAGE = {86718},
        ROGUE = {86642},
    },
    [89271] = { -- Gauntlets of the Shadowy Conqueror
        PALADIN = {86682, 86662, 86687},
        PRIEST = {86704, 86703},
        WARLOCK = {86709},
    },
    [89272] = { -- Gauntlets of the Shadowy Protector
        HUNTER = {86637},
        MONK = {86729, 86735, 86727},
        SHAMAN = {86627, 86692, 86630},
        WARRIOR = {86667, 86671},
    },
    [89273] = { -- Helm of the Shadowy Vanquisher
        DEATHKNIGHT = {86656, 86676},
        DRUID = {86697, 86651, 86721, 86647},
        MAGE = {86717},
        ROGUE = {86641},
    },
    [89274] = { -- Helm of the Shadowy Conqueror
        PALADIN = {86681, 86661, 86686},
        PRIEST = {86705, 86702},
        WARLOCK = {86710},
    },
    [89275] = { -- Helm of the Shadowy Protector
        HUNTER = {86636},
        MONK = {86736, 86730, 86726},
        SHAMAN = {86626, 86691, 86631},
        WARRIOR = {86673, 86666},
    },
    [89276] = { -- Shoulders of the Shadowy Vanquisher
        DEATHKNIGHT = {86674, 86654},
        DRUID = {86649, 86723, 86644, 86694},
        MAGE = {86714},
        ROGUE = {86639},
    },
    [89277] = { -- Shoulders of the Shadowy Conqueror
        PALADIN = {86659, 86684, 86679},
        PRIEST = {86699, 86708},
        WARLOCK = {86713},
    },
    [89278] = { -- Shoulders of the Shadowy Protector
        HUNTER = {86634},
        MONK = {86738, 86724, 86733},
        SHAMAN = {86624, 86633, 86689},
        WARRIOR = {86664, 86669},
    },
    [95569] = { -- Chest of the Crackling Vanquisher
        DEATHKNIGHT = {95225, 95230},
        DRUID = {95243, 95248, 95250, 95235},
        MAGE = {95263},
        ROGUE = {95305},
    },
    [95570] = { -- Gauntlets of the Crackling Vanquisher
        DEATHKNIGHT = {95226, 95231},
        DRUID = {95240, 95251, 95236, 95245},
        MAGE = {95260},
        ROGUE = {95306},
    },
    [95571] = { -- Helm of the Crackling Vanquisher
        DEATHKNIGHT = {95232, 95227},
        DRUID = {95241, 95252, 95237, 95246},
        MAGE = {95261},
        ROGUE = {95307},
    },
    [95572] = { -- Leggings of the Crackling Vanquisher
        DEATHKNIGHT = {95233, 95228},
        DRUID = {95242, 95253, 95238, 95247},
        MAGE = {95262},
        ROGUE = {95308},
    },
    [95573] = { -- Shoulders of the Crackling Vanquisher
        DEATHKNIGHT = {95234, 95229},
        DRUID = {95249, 95244, 95254, 95239},
        MAGE = {95264},
        ROGUE = {95309},
    },
    [95574] = { -- Chest of the Crackling Conqueror
        PALADIN = {95280, 95290, 95285},
        PRIEST = {95298, 95303},
        WARLOCK = {95328},
    },
    [95575] = { -- Gauntlets of the Crackling Conqueror
        PALADIN = {95281, 95291, 95286},
        PRIEST = {95300, 95295},
        WARLOCK = {95325},
    },
    [95576] = { -- Leggings of the Crackling Conqueror
        PALADIN = {95288, 95283, 95293},
        PRIEST = {95297, 95302},
        WARLOCK = {95327},
    },
    [95577] = { -- Helm of the Crackling Conqueror
        PALADIN = {95282, 95292, 95287},
        PRIEST = {95296, 95301},
        WARLOCK = {95326},
    },
    [95578] = { -- Shoulders of the Crackling Conqueror
        PALADIN = {95289, 95284, 95294},
        PRIEST = {95304, 95299},
        WARLOCK = {95329},
    },
    [95579] = { -- Chest of the Crackling Protector
        HUNTER = {95255},
        MONK = {95265, 95275, 95273},
        SHAMAN = {95320, 95315, 95310},
        WARRIOR = {95331, 95335},
    },
    [95580] = { -- Gauntlets of the Crackling Protector
        HUNTER = {95256},
        MONK = {95266, 95276, 95270},
        SHAMAN = {95321, 95316, 95311},
        WARRIOR = {95336, 95332},
    },
    [95581] = { -- Leggings of the Crackling Protector
        HUNTER = {95258},
        MONK = {95272, 95268, 95278},
        SHAMAN = {95313, 95323, 95318},
        WARRIOR = {95338, 95333},
    },
    [95582] = { -- Helm of the Crackling Protector
        HUNTER = {95257},
        MONK = {95267, 95277, 95271},
        SHAMAN = {95312, 95322, 95317},
        WARRIOR = {95337, 95330},
    },
    [95583] = { -- Shoulders of the Crackling Protector
        HUNTER = {95259},
        MONK = {95274, 95269, 95279},
        SHAMAN = {95314, 95324, 95319},
        WARRIOR = {95339, 95334},
    },
    [95822] = { -- Chest of the Crackling Vanquisher
        DEATHKNIGHT = {95825, 95830},
        DRUID = {95848, 95850, 95835, 95843},
        MAGE = {95893},
        ROGUE = {95935},
    },
    [95823] = { -- Chest of the Crackling Conqueror
        PALADIN = {95920, 95915, 95910},
        PRIEST = {95928, 95933},
        WARLOCK = {95984},
    },
    [95824] = { -- Chest of the Crackling Protector
        HUNTER = {95882},
        MONK = {95903, 95905, 95895},
        SHAMAN = {95945, 95940, 95950},
        WARRIOR = {95987, 95991},
    },
    [95855] = { -- Gauntlets of the Crackling Vanquisher
        DEATHKNIGHT = {95826, 95831},
        DRUID = {95840, 95851, 95836, 95845},
        MAGE = {95890},
        ROGUE = {95936},
    },
    [95856] = { -- Gauntlets of the Crackling Conqueror
        PALADIN = {95921, 95916, 95911},
        PRIEST = {95930, 95925},
        WARLOCK = {95981},
    },
    [95857] = { -- Gauntlets of the Crackling Protector
        HUNTER = {95883},
        MONK = {95896, 95906, 95900},
        SHAMAN = {95946, 95941, 95951},
        WARRIOR = {95992, 95988},
    },
    [95879] = { -- Helm of the Crackling Vanquisher
        DEATHKNIGHT = {95832, 95827},
        DRUID = {95841, 95852, 95837, 95846},
        MAGE = {95891},
        ROGUE = {95937},
    },
    [95880] = { -- Helm of the Crackling Conqueror
        PALADIN = {95912, 95922, 95917},
        PRIEST = {95931, 95926},
        WARLOCK = {95982},
    },
    [95881] = { -- Helm of the Crackling Protector
        HUNTER = {95884},
        MONK = {95897, 95907, 95901},
        SHAMAN = {95952, 95947, 95942},
        WARRIOR = {95993, 95986},
    },
    [95887] = { -- Leggings of the Crackling Vanquisher
        DEATHKNIGHT = {95833, 95828},
        DRUID = {95842, 95853, 95838, 95847},
        MAGE = {95892},
        ROGUE = {95938},
    },
    [95888] = { -- Leggings of the Crackling Conqueror
        PALADIN = {95913, 95923, 95918},
        PRIEST = {95932, 95927},
        WARLOCK = {95983},
    },
    [95889] = { -- Leggings of the Crackling Protector
        HUNTER = {95885},
        MONK = {95898, 95908, 95902},
        SHAMAN = {95953, 95948, 95943},
        WARRIOR = {95994, 95989},
    },
    [95955] = { -- Shoulders of the Crackling Vanquisher
        DEATHKNIGHT = {95834, 95829},
        DRUID = {95849, 95844, 95854, 95839},
        MAGE = {95894},
        ROGUE = {95939},
    },
    [95956] = { -- Shoulders of the Crackling Conqueror
        PALADIN = {95914, 95924, 95919},
        PRIEST = {95929, 95934},
        WARLOCK = {95985},
    },
    [95957] = { -- Shoulders of the Crackling Protector
        HUNTER = {95886},
        MONK = {95904, 95899, 95909},
        SHAMAN = {95944, 95954, 95949},
        WARRIOR = {95995, 95990},
    },
    [96566] = { -- Chest of the Crackling Vanquisher
        DEATHKNIGHT = {96569, 96574},
        DRUID = {96592, 96587, 96579, 96594},
        MAGE = {96637},
        ROGUE = {96679},
    },
    [96567] = { -- Chest of the Crackling Conqueror
        PALADIN = {96664, 96659, 96654},
        PRIEST = {96672, 96677},
        WARLOCK = {96728},
    },
    [96568] = { -- Chest of the Crackling Protector
        HUNTER = {96626},
        MONK = {96647, 96649, 96639},
        SHAMAN = {96689, 96684, 96694},
        WARRIOR = {96731, 96735},
    },
    [96599] = { -- Gauntlets of the Crackling Vanquisher
        DEATHKNIGHT = {96570, 96575},
        DRUID = {96584, 96595, 96580, 96589},
        MAGE = {96634},
        ROGUE = {96680},
    },
    [96600] = { -- Gauntlets of the Crackling Conqueror
        PALADIN = {96665, 96660, 96655},
        PRIEST = {96674, 96669},
        WARLOCK = {96725},
    },
    [96601] = { -- Gauntlets of the Crackling Protector
        HUNTER = {96627},
        MONK = {96640, 96650, 96644},
        SHAMAN = {96690, 96685, 96695},
        WARRIOR = {96736, 96732},
    },
    [96623] = { -- Helm of the Crackling Vanquisher
        DEATHKNIGHT = {96576, 96571},
        DRUID = {96585, 96596, 96581, 96590},
        MAGE = {96635},
        ROGUE = {96681},
    },
    [96624] = { -- Helm of the Crackling Conqueror
        PALADIN = {96656, 96666, 96661},
        PRIEST = {96675, 96670},
        WARLOCK = {96726},
    },
    [96625] = { -- Helm of the Crackling Protector
        HUNTER = {96628},
        MONK = {96641, 96651, 96645},
        SHAMAN = {96696, 96691, 96686},
        WARRIOR = {96737, 96730},
    },
    [96631] = { -- Leggings of the Crackling Vanquisher
        DEATHKNIGHT = {96577, 96572},
        DRUID = {96586, 96597, 96582, 96591},
        MAGE = {96636},
        ROGUE = {96682},
    },
    [96632] = { -- Leggings of the Crackling Conqueror
        PALADIN = {96657, 96667, 96662},
        PRIEST = {96676, 96671},
        WARLOCK = {96727},
    },
    [96633] = { -- Leggings of the Crackling Protector
        HUNTER = {96629},
        MONK = {96642, 96652, 96646},
        SHAMAN = {96697, 96692, 96687},
        WARRIOR = {96738, 96733},
    },
    [96699] = { -- Shoulders of the Crackling Vanquisher
        DEATHKNIGHT = {96578, 96573},
        DRUID = {96593, 96588, 96598, 96583},
        MAGE = {96638},
        ROGUE = {96683},
    },
    [96700] = { -- Shoulders of the Crackling Conqueror
        PALADIN = {96658, 96668, 96663},
        PRIEST = {96673, 96678},
        WARLOCK = {96729},
    },
    [96701] = { -- Shoulders of the Crackling Protector
        HUNTER = {96630},
        MONK = {96648, 96643, 96653},
        SHAMAN = {96688, 96698, 96693},
        WARRIOR = {96739, 96734},
    },
    [99667] = { -- Gauntlets of the Cursed Protector
        HUNTER = {99086},
        MONK = {99064, 99072, 99068},
        SHAMAN = {99088, 98993, 98988},
        WARRIOR = {99034, 99038},
    },
    [99668] = { -- Shoulders of the Cursed Vanquisher
        DEATHKNIGHT = {99040, 99059},
        DRUID = {99016, 98978, 99022, 98998},
        MAGE = {99079},
        ROGUE = {99010},
    },
    [99669] = { -- Shoulders of the Cursed Conqueror
        PALADIN = {98987, 99076, 99027},
        PRIEST = {99018, 99005},
        WARLOCK = {99045},
    },
    [99670] = { -- Shoulders of the Cursed Protector
        HUNTER = {99082},
        MONK = {99075, 99051, 99062},
        SHAMAN = {98977, 99091, 98991},
        WARRIOR = {99036, 99030},
    },
    [99671] = { -- Helm of the Cursed Vanquisher
        DEATHKNIGHT = {99049, 99057},
        DRUID = {99001, 98995, 99043, 99013},
        MAGE = {99084},
        ROGUE = {99008},
    },
    [99672] = { -- Helm of the Cursed Conqueror
        PALADIN = {98985, 98979, 99029},
        PRIEST = {99024, 99020},
        WARLOCK = {99054},
    },
    [99673] = { -- Helm of the Cursed Protector
        HUNTER = {99080},
        MONK = {99065, 99069, 99073},
        SHAMAN = {99089, 98989, 98983},
        WARRIOR = {99032, 99046},
    },
    [99674] = { -- Leggings of the Cursed Vanquisher
        DEATHKNIGHT = {99058, 99039},
        DRUID = {99044, 98996, 98981, 99014},
        MAGE = {99077},
        ROGUE = {99009},
    },
    [99675] = { -- Leggings of the Cursed Conqueror
        PALADIN = {99026, 98986, 98980},
        PRIEST = {99025, 99021},
        WARLOCK = {99055},
    },
    [99676] = { -- Leggings of the Cursed Protector
        HUNTER = {99081},
        MONK = {99050, 99074, 99070},
        SHAMAN = {98984, 99090, 98990},
        WARRIOR = {99033, 99035},
    },
    [99677] = { -- Chest of the Cursed Vanquisher
        DEATHKNIGHT = {99066, 99060},
        DRUID = {99041, 98997, 98999, 99015},
        MAGE = {99078},
        ROGUE = {99006},
    },
    [99678] = { -- Chest of the Cursed Conqueror
        PALADIN = {99003, 99052, 99031},
        PRIEST = {99017, 99004},
        WARLOCK = {99056},
    },
    [99679] = { -- Chest of the Cursed Protector
        HUNTER = {99085},
        MONK = {99071, 99061, 99063},
        SHAMAN = {98992, 99011, 99087},
        WARRIOR = {99037, 99047},
    },
    [99680] = { -- Gauntlets of the Cursed Vanquisher
        DEATHKNIGHT = {99048, 99067},
        DRUID = {99000, 98994, 99042, 99012},
        MAGE = {99083},
        ROGUE = {99007},
    },
    [99681] = { -- Gauntlets of the Cursed Conqueror
        PALADIN = {99002, 99028, 98982},
        PRIEST = {99019, 99023},
        WARLOCK = {99053},
    },
    [99682] = { -- Gauntlets of the Cursed Vanquisher
        DEATHKNIGHT = {99193, 99189},
        DRUID = {99185, 99163, 99181, 99174},
        MAGE = {99160},
        ROGUE = {99113},
    },
    [99683] = { -- Helm of the Cursed Vanquisher
        DEATHKNIGHT = {99194, 99190},
        DRUID = {99178, 99164, 99182, 99175},
        MAGE = {99161},
        ROGUE = {99114},
    },
    [99684] = { -- Leggings of the Cursed Vanquisher
        DEATHKNIGHT = {99186, 99191},
        DRUID = {99176, 99171, 99165, 99183},
        MAGE = {99162},
        ROGUE = {99115},
    },
    [99685] = { -- Shoulders of the Cursed Vanquisher
        DEATHKNIGHT = {99187, 99179},
        DRUID = {99184, 99169, 99173, 99166},
        MAGE = {99153},
        ROGUE = {99116},
    },
    [99686] = { -- Chest of the Cursed Conqueror
        PALADIN = {99136, 99133, 99126},
        PRIEST = {99110, 99119},
        WARLOCK = {99204},
    },
    [99687] = { -- Gauntlets of the Cursed Conqueror
        PALADIN = {99137, 99134, 99127},
        PRIEST = {99121, 99131},
        WARLOCK = {99096},
    },
    [99688] = { -- Leggings of the Cursed Conqueror
        PALADIN = {99129, 99139, 99124},
        PRIEST = {99123, 99118},
        WARLOCK = {99098},
    },
    [99689] = { -- Helm of the Cursed Conqueror
        PALADIN = {99128, 99138, 99135},
        PRIEST = {99122, 99117},
        WARLOCK = {99097},
    },
    [99690] = { -- Shoulders of the Cursed Conqueror
        PALADIN = {99130, 99132, 99125},
        PRIEST = {99120, 99111},
        WARLOCK = {99205},
    },
    [99691] = { -- Chest of the Cursed Protector
        HUNTER = {99167},
        MONK = {99154, 99140, 99150},
        SHAMAN = {99106, 99107, 99101},
        WARRIOR = {99201, 99197},
    },
    [99692] = { -- Gauntlets of the Cursed Protector
        HUNTER = {99168},
        MONK = {99155, 99147, 99141},
        SHAMAN = {99092, 99102, 99108},
        WARRIOR = {99202, 99198},
    },
    [99693] = { -- Leggings of the Cursed Protector
        HUNTER = {99158},
        MONK = {99145, 99149, 99143},
        SHAMAN = {99104, 99099, 99094},
        WARRIOR = {99195, 99199},
    },
    [99694] = { -- Helm of the Cursed Protector
        HUNTER = {99157},
        MONK = {99148, 99142, 99156},
        SHAMAN = {99109, 99093, 99103},
        WARRIOR = {99203, 99206},
    },
    [99695] = { -- Shoulders of the Cursed Protector
        HUNTER = {99159},
        MONK = {99144, 99146, 99151},
        SHAMAN = {99105, 99100, 99095},
        WARRIOR = {99200, 99196},
    },
    [99696] = { -- Chest of the Cursed Vanquisher
        DEATHKNIGHT = {99192, 99188},
        DRUID = {99180, 99177, 99170, 99172},
        MAGE = {99152},
        ROGUE = {99112},
    },
    [99712] = { -- Leggings of the Cursed Conqueror
        PALADIN = {99377, 99371, 99372},
        PRIEST = {99361, 99367},
        WARLOCK = {99426},
    },
    [99713] = { -- Leggings of the Cursed Protector
        HUNTER = {99403},
        MONK = {99385, 99394, 99390},
        SHAMAN = {99354, 99333, 99342},
        WARRIOR = {99410, 99413},
    },
    [99714] = { -- Chest of the Cursed Vanquisher
        DEATHKNIGHT = {99330, 99335},
        DRUID = {99427, 99430, 99419, 99326},
        MAGE = {99400},
        ROGUE = {99356},
    },
    [99715] = { -- Chest of the Cursed Conqueror
        PALADIN = {99368, 99387, 99374},
        PRIEST = {99362, 99357},
        WARLOCK = {99416},
    },
    [99716] = { -- Chest of the Cursed Protector
        HUNTER = {99405},
        MONK = {99396, 99382, 99391},
        SHAMAN = {99344, 99347, 99351},
        WARRIOR = {99411, 99415},
    },
    [99717] = { -- Shoulders of the Cursed Vanquisher
        DEATHKNIGHT = {99339, 99325},
        DRUID = {99322, 99428, 99431, 99423},
        MAGE = {99401},
        ROGUE = {99350},
    },
    [99718] = { -- Shoulders of the Cursed Conqueror
        PALADIN = {99378, 99364, 99373},
        PRIEST = {99363, 99358},
        WARLOCK = {99417},
    },
    [99719] = { -- Shoulders of the Cursed Protector
        HUNTER = {99404},
        MONK = {99386, 99395, 99381},
        SHAMAN = {99346, 99334, 99343},
        WARRIOR = {99414, 99407},
    },
    [99720] = { -- Gauntlets of the Cursed Vanquisher
        DEATHKNIGHT = {99336, 99331},
        DRUID = {99432, 99435, 99420, 99327},
        MAGE = {99397},
        ROGUE = {99355},
    },
    [99721] = { -- Gauntlets of the Cursed Conqueror
        PALADIN = {99369, 99380, 99375},
        PRIEST = {99365, 99359},
        WARLOCK = {99424},
    },
    [99722] = { -- Gauntlets of the Cursed Protector
        HUNTER = {99406},
        MONK = {99392, 99388, 99383},
        SHAMAN = {99352, 99345, 99340},
        WARRIOR = {99408, 99412},
    },
    [99723] = { -- Helm of the Cursed Vanquisher
        DEATHKNIGHT = {99337, 99323},
        DRUID = {99328, 99433, 99436, 99421},
        MAGE = {99398},
        ROGUE = {99348},
    },
    [99724] = { -- Helm of the Cursed Conqueror
        PALADIN = {99376, 99370, 99379},
        PRIEST = {99360, 99366},
        WARLOCK = {99425},
    },
    [99725] = { -- Helm of the Cursed Protector
        HUNTER = {99402},
        MONK = {99384, 99393, 99389},
        SHAMAN = {99353, 99332, 99341},
        WARRIOR = {99409, 99418},
    },
    [99726] = { -- Leggings of the Cursed Vanquisher
        DEATHKNIGHT = {99338, 99324},
        DRUID = {99329, 99434, 99429, 99422},
        MAGE = {99399},
        ROGUE = {99349},
    },
    [99742] = { -- Chest of the Cursed Vanquisher
        DEATHKNIGHT = {99608, 99640},
        DRUID = {99622, 99632, 99620, 99582},
        MAGE = {99658},
        ROGUE = {99629},
    },
    [99743] = { -- Chest of the Cursed Conqueror
        PALADIN = {99626, 99566, 99598},
        PRIEST = {99584, 99627},
        WARLOCK = {99570},
    },
    [99744] = { -- Chest of the Cursed Protector
        HUNTER = {99577},
        MONK = {99641, 99555, 99643},
        SHAMAN = {99579, 99636, 99615},
        WARRIOR = {99562, 99603},
    },
    [99745] = { -- Gauntlets of the Cursed Vanquisher
        DEATHKNIGHT = {99609, 99604},
        DRUID = {99617, 99637, 99633, 99623},
        MAGE = {99575},
        ROGUE = {99630},
    },
    [99746] = { -- Gauntlets of the Cursed Conqueror
        PALADIN = {99648, 99625, 99595},
        PRIEST = {99586, 99590},
        WARLOCK = {99567},
    },
    [99747] = { -- Gauntlets of the Cursed Protector
        HUNTER = {99578},
        MONK = {99552, 99556, 99644},
        SHAMAN = {99616, 99611, 99580},
        WARRIOR = {99563, 99559},
    },
    [99748] = { -- Helm of the Cursed Vanquisher
        DEATHKNIGHT = {99571, 99605},
        DRUID = {99624, 99618, 99638, 99599},
        MAGE = {99576},
        ROGUE = {99631},
    },
    [99749] = { -- Helm of the Cursed Conqueror
        PALADIN = {99665, 99651, 99596},
        PRIEST = {99587, 99591},
        WARLOCK = {99568},
    },
    [99750] = { -- Helm of the Cursed Protector
        HUNTER = {99660},
        MONK = {99553, 99653, 99607},
        SHAMAN = {99649, 99612, 99645},
        WARRIOR = {99602, 99557},
    },
    [99751] = { -- Leggings of the Cursed Vanquisher
        DEATHKNIGHT = {99564, 99572},
        DRUID = {99600, 99610, 99619, 99581},
        MAGE = {99657},
        ROGUE = {99634},
    },
    [99752] = { -- Leggings of the Cursed Conqueror
        PALADIN = {99593, 99666, 99661},
        PRIEST = {99592, 99588},
        WARLOCK = {99569},
    },
    [99753] = { -- Leggings of the Cursed Protector
        HUNTER = {99573},
        MONK = {99654, 99554, 99606},
        SHAMAN = {99650, 99613, 99646},
        WARRIOR = {99560, 99558},
    },
    [99754] = { -- Shoulders of the Cursed Vanquisher
        DEATHKNIGHT = {99652, 99639},
        DRUID = {99664, 99621, 99589, 99583},
        MAGE = {99659},
        ROGUE = {99635},
    },
    [99755] = { -- Shoulders of the Cursed Conqueror
        PALADIN = {99656, 99594, 99662},
        PRIEST = {99585, 99628},
        WARLOCK = {99601},
    },
    [99756] = { -- Shoulders of the Cursed Protector
        HUNTER = {99574},
        MONK = {99642, 99565, 99655},
        SHAMAN = {99663, 99614, 99647},
        WARRIOR = {99561, 99597},
    },
}
-- END DATA
